<script setup>
import { ref } from 'vue'
import { DefaultApi, Configuration } from '../../openapi/generated'

import SearchForm from '../molecules/SearchForm.vue'

const props = defineProps({
  type: {
    type: String,
    required: true
  },
  apiUrl: {
    type: String,
    default: 'http://localhost:1323'
  }
})
const emit = defineEmits(['search'])

const searchQuery = ref('')
const resultMemoMap = ref({})

// init api
const conf = new Configuration({
  basePath: props.apiUrl,
})
const api = new DefaultApi(conf)


const searchMemoByText = (target) => {
  console.log('searchMemoByText')
  const form = new FormData(target)
  console.log(form)

  api.findMemos({
    text: form.get('text')
  }).then(memos => {
    console.log(memos)
    resultMemoMap.value = {}
    memos.map(memo => {
      resultMemoMap.value[memo.id] = memo
    })

    emit('search', resultMemoMap.value)
  })
}

const searchMemosByTag = (target) => {
  console.log('searchMemosByTag')
  const form = new FormData(target)
  console.log(form)

  api.findMemos({
    tags: form.get('text')
  }).then(memos => {
    console.log(memos)
    resultMemoMap.value = {}
    memos.map(memo => {
      resultMemoMap.value[memo.id] = memo
    })

    emit('search', resultMemoMap.value)
  })
}
</script>

<template>
  <div>
    <SearchForm
      v-if="type === 'text'"
      placeholder="Search text"
      @submit="searchMemoByText"
    />

    <SearchForm
      v-else
      placeholder="Search tag"
      @submit="searchMemosByTag"
    />
  </div>
</template>

<style scoped>

</style>

